# coding: utf-8

"""
    Zarban API

    API for Zarban services.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: info@zarban.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from zarban.service.openapi_client.configuration import Configuration


class UserStake(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'user': 'str',
        'balance': 'StakeBalance',
        'unclaimed_reward': 'UnclaimedReward',
        'contract_address': 'str',
        'plan_name': 'str'
    }

    attribute_map = {
        'user': 'user',
        'balance': 'balance',
        'unclaimed_reward': 'unclaimedReward',
        'contract_address': 'contractAddress',
        'plan_name': 'planName'
    }

    def __init__(self, user=None, balance=None, unclaimed_reward=None, contract_address=None, plan_name=None, local_vars_configuration=None):  # noqa: E501
        """UserStake - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._user = None
        self._balance = None
        self._unclaimed_reward = None
        self._contract_address = None
        self._plan_name = None
        self.discriminator = None

        self.user = user
        self.balance = balance
        self.unclaimed_reward = unclaimed_reward
        self.contract_address = contract_address
        self.plan_name = plan_name

    @property
    def user(self):
        """Gets the user of this UserStake.  # noqa: E501

        Ethereum address of the user  # noqa: E501

        :return: The user of this UserStake.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this UserStake.

        Ethereum address of the user  # noqa: E501

        :param user: The user of this UserStake.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and user is None:  # noqa: E501
            raise ValueError("Invalid value for `user`, must not be `None`")  # noqa: E501

        self._user = user

    @property
    def balance(self):
        """Gets the balance of this UserStake.  # noqa: E501


        :return: The balance of this UserStake.  # noqa: E501
        :rtype: StakeBalance
        """
        return self._balance

    @balance.setter
    def balance(self, balance):
        """Sets the balance of this UserStake.


        :param balance: The balance of this UserStake.  # noqa: E501
        :type: StakeBalance
        """
        if self.local_vars_configuration.client_side_validation and balance is None:  # noqa: E501
            raise ValueError("Invalid value for `balance`, must not be `None`")  # noqa: E501

        self._balance = balance

    @property
    def unclaimed_reward(self):
        """Gets the unclaimed_reward of this UserStake.  # noqa: E501


        :return: The unclaimed_reward of this UserStake.  # noqa: E501
        :rtype: UnclaimedReward
        """
        return self._unclaimed_reward

    @unclaimed_reward.setter
    def unclaimed_reward(self, unclaimed_reward):
        """Sets the unclaimed_reward of this UserStake.


        :param unclaimed_reward: The unclaimed_reward of this UserStake.  # noqa: E501
        :type: UnclaimedReward
        """
        if self.local_vars_configuration.client_side_validation and unclaimed_reward is None:  # noqa: E501
            raise ValueError("Invalid value for `unclaimed_reward`, must not be `None`")  # noqa: E501

        self._unclaimed_reward = unclaimed_reward

    @property
    def contract_address(self):
        """Gets the contract_address of this UserStake.  # noqa: E501

        Ethereum address of the staking contract  # noqa: E501

        :return: The contract_address of this UserStake.  # noqa: E501
        :rtype: str
        """
        return self._contract_address

    @contract_address.setter
    def contract_address(self, contract_address):
        """Sets the contract_address of this UserStake.

        Ethereum address of the staking contract  # noqa: E501

        :param contract_address: The contract_address of this UserStake.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and contract_address is None:  # noqa: E501
            raise ValueError("Invalid value for `contract_address`, must not be `None`")  # noqa: E501

        self._contract_address = contract_address

    @property
    def plan_name(self):
        """Gets the plan_name of this UserStake.  # noqa: E501

        Name of staking plan  # noqa: E501

        :return: The plan_name of this UserStake.  # noqa: E501
        :rtype: str
        """
        return self._plan_name

    @plan_name.setter
    def plan_name(self, plan_name):
        """Sets the plan_name of this UserStake.

        Name of staking plan  # noqa: E501

        :param plan_name: The plan_name of this UserStake.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and plan_name is None:  # noqa: E501
            raise ValueError("Invalid value for `plan_name`, must not be `None`")  # noqa: E501

        self._plan_name = plan_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserStake):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserStake):
            return True

        return self.to_dict() != other.to_dict()
